#pragma once

#define INFINITY 2147483647					// 2^31-1
#define UINFINITY 4294967295				// 2^32-1
#define INVALID 4294967295
#define NEG_INFINITY -(INFINITY-1)
#define EXTRA 1
#define AVOIDNULL(pointer,expression) ((pointer==NULL) ? 1 : expression)
#define ARNULL(array,index) ((array==NULL) ? NULL : array[index])


typedef struct _dij_elm
{	// prnode is the parent node.
	
	long dist;
	unsigned long node;
	unsigned long prnode;
} dij_elm;

typedef struct _path
{	unsigned long *par;
	long tot_cost;
	unsigned long size;
} path;

typedef struct _sized_paths
{	path *ppaths;
	unsigned long size;
} sized_paths;



void **Malloc2D(unsigned long d1_size,unsigned long d2_size,unsigned long elem_bytes);

void AddConst2D(long **ar2D,unsigned long d1_size,unsigned long d2_size,long c);

void Copy2D(long **d_ar2D,const long **s_ar2D,unsigned long d1_size,unsigned long d2_size);

void MinConst2D(long **ar2D,unsigned long d1_size,unsigned long d2_size,long c);

void MaxConst2D(long **ar2D,unsigned long d1_size,unsigned long d2_size,long c);

long *Dijkstra(long **graph,unsigned long nodes,unsigned long startn);

path *DijkstraPaths(long **graph,unsigned long nodes,unsigned long startn);

long **FindGraphLeastCosts(long **graph,unsigned long nodes);

void PrintPath(unsigned long y, unsigned long x, path pr_path);

void PrintGraphPaths(sized_paths **graph_paths,unsigned long nodes);

void FindPathsExt(long **graph, unsigned long nodes,long fnode, sized_paths *paths_store,long lmin_cost,long lmax_cost ,unsigned long lmin_size,unsigned long lmax_size);

void FindPaths(long **graph, unsigned long nodes,long fnode, sized_paths *paths_store);

void FindPathsExt2(long **graph, unsigned long nodes,long fnode, sized_paths *paths_store, long *pmin_cost, long *pmax_cost, unsigned long *pmin_size, unsigned long *pmax_size);

sized_paths **FindGraphPaths(long **graph,unsigned long nodes);

sized_paths **FindGraphPathsExt(long **graph,unsigned long nodes,long lmin_cost,long lmax_cost ,unsigned long lmin_size,unsigned long lmax_size);

sized_paths **FindGraphPathsExt2(long **graph,unsigned long nodes,long **pgraph_min_cost, long **pgraph_max_cost, unsigned long **pgraph_min_size, unsigned long **pgraph_max_size);

void TruncateSizedPaths(sized_paths *p_paths, unsigned long max_paths);

void TruncateGraphPaths(sized_paths **graph_paths,unsigned long nodes,unsigned long max_paths);

sized_paths **CreateEmptyGraphPaths(unsigned long nodes);

long CalcPathCost(unsigned long y,long **graph, path dpath);

void ClonePath(const path *spath, path *dpath);

void FreeSizedPaths(sized_paths *p_paths);

void FreeGraphPaths(sized_paths **graph_paths,unsigned long nodes); 

